Properties Methods Events Config Options Direct Link

    Observable
      Component
        BoxComponent
          Field
            TextField
              TriggerField
                DateField

# Class Ext.form.DateField

Package: | Ext.form
Defined In: | DateField.js
Class: | DateField
Extends: | TriggerField

Provides a date input field with a Ext.DatePicker dropdown and automatic date validation.

## Config Options

Config Options | Defined By
--- | ---
| allowBlank : Boolean Specify `false` to validate that the value's length is > 0 (defaults to `true`) | TextField
| allowDomMove : Boolean Whether the component can move the Dom node when rendering (defaults to true). | Component
| altFormats : String Multiple date formats separated by "|" to try when parsing a user input value and it does not match the defined forma... Multiple date formats separated by "`|`" to try when parsing a user input value and it does not match the defined format (defaults to `'m/d/Y|n/j/Y|n/j/y|m/j/y|n/d/y|m/j/Y|n/d/Y|m-d-y|m-d-Y|m/d|m-d|md|mdy|mdY|d|Y-m-d|n-j|n/j'`). | DateField

anchor : String
Note: this config is only used when this Component is rendered by a Container which has been configured to use an Anc...

Note: this config is only used when this Component is rendered by a Container which has been configured to use an AnchorLayout (or subclass thereof). based layout manager, for example:

- Ext.form.FormPanel
- specifying `layout: 'anchor' // or 'form', or 'absolute'`

See Ext.layout.AnchorLayout.anchor also.

BoxComponent

applyTo : Mixed
Specify the id of the element, a DOM element or an existing Element corresponding to a DIV that is already present in...

Specify the id of the element, a DOM element or an existing Element corresponding to a DIV that is already present in the document that specifies some structural markup for this component.

- Description :
  When `applyTo` is used, constituent parts of the component can also be specified by id or CSS class name within the main element, and the component being created may attempt to create its subcomponents from that markup if applicable.
- Notes :
  When using this config, a call to render() is not required.
  If applyTo is specified, any value passed for renderTo will be ignored and the target element's parent node will automatically be used as the component's container.

Component

autoCreate : String/Object
A DomHelper element specification object, or true for the default element specification object:autoCreate: {tag: "inp...
A DomHelper element specification object, or `true` for the default element specification object:

    autoCreate: {tag: "input", type: "text", size: "10", autocomplete: "off"}

DateField

| autoScroll : Boolean true to use overflow:'auto' on the components layout element and show scroll bars automatically when necessary, false... `true` to use overflow:'auto' on the components layout element and show scroll bars automatically when necessary, `false` to clip any overflowing content (defaults to `false`). | BoxComponent
| autoShow : Boolean True if the component should check for hidden classes (e.g. 'x-hidden' or 'x-hide-display') and remove them on render... True if the component should check for hidden classes (e.g. 'x-hidden' or 'x-hide-display') and remove them on render (defaults to false). | Component
| blankText : String The error text to display if the `allowBlank` validation fails (defaults to `'This field is required'`) | TextField
| boxMaxHeight : Number The maximum value in pixels which this BoxComponent will set its height to. Warning: This will override any size mana... The maximum value in pixels which this BoxComponent will set its height to. Warning: This will override any size management applied by layout managers. | BoxComponent
| boxMaxWidth : Number The maximum value in pixels which this BoxComponent will set its width to. Warning: This will override any size manag... The maximum value in pixels which this BoxComponent will set its width to. Warning: This will override any size management applied by layout managers. | BoxComponent
| boxMinHeight : Number The minimum value in pixels which this BoxComponent will set its height to. Warning: This will override any size mana... The minimum value in pixels which this BoxComponent will set its height to. Warning: This will override any size management applied by layout managers. | BoxComponent
| boxMinWidth : Number The minimum value in pixels which this BoxComponent will set its width to. Warning: This will override any size manag... The minimum value in pixels which this BoxComponent will set its width to. Warning: This will override any size management applied by layout managers. | BoxComponent
| bubbleEvents : Array An array of events that, when fired, should be bubbled to any parent container. See Ext.util.Observable.enableBubble.... An array of events that, when fired, should be bubbled to any parent container. See Ext.util.Observable.enableBubble. Defaults to `[]`. | Component

clearCls : String
The CSS class used to to apply to the special clearing div rendered directly after each form field wrapper to provide...

The CSS class used to to apply to the special clearing div rendered directly after each form field wrapper to provide field clearing (defaults to `'x-form-clear-left'`).

Note: this config is only used when this Component is rendered by a Container which has been configured to use the FormLayout layout manager (e.g. Ext.form.FormPanel or specifying `layout:'form'`) and either a `fieldLabel` is specified or `isFormField=true` is specified.

See Ext.layout.FormLayout.fieldTpl also.

Component

| cls : String A custom CSS class to apply to the field's underlying element (defaults to ''). | Field

contentEl : String
Optional. Specify an existing HTML element, or the id of an existing HTML element to use as the content for this comp...

Optional. Specify an existing HTML element, or the `id` of an existing HTML element to use as the content for this component.

- Description :
  This config option is used to take an existing HTML element and place it in the layout element of a new component (it simply moves the specified DOM element after the Component is rendered to use as the content.
- Notes :
  The specified HTML element is appended to the layout element of the component after any configured HTML has been inserted, and so the document will not contain this element at the time the render event is fired.
  The specified HTML element used will not participate in any `layout` scheme that the Component may use. It is just HTML. Layouts operate on child `items`.
  Add either the `x-hidden` or the `x-hide-display` CSS class to prevent a brief flicker of the content before it is rendered to the panel.

Component

ctCls : String
An optional extra CSS class that will be added to this component's container. This can be useful for adding customize...

An optional extra CSS class that will be added to this component's container. This can be useful for adding customized styles to the container or any of its children using standard CSS rules. See Ext.layout.ContainerLayout.extraCls also.

Note: `ctCls` defaults to `''` except for the following class which assigns a value by default:

- Box Layout : `'x-box-layout-ct'`

To configure the above Class with an extra CSS class append to the default. For example, for BoxLayout (Hbox and Vbox):

    ctCls: 'x-box-layout-ct custom-class'

Component

| data : Mixed The initial set of data to apply to the `tpl` to update the content area of the Component. | Component
| disableKeyFilter : Boolean Specify `true` to disable input keystroke filtering (defaults to `false`) | TextField
| disabled : Boolean True to disable the field (defaults to false). Be aware that conformant with the <a href="http://www.w3.org/TR/html40... True to disable the field (defaults to false). Be aware that conformant with the HTML specification, disabled Fields will not be submitted. | Field
| disabledClass : String CSS class added to the component when it is disabled (defaults to 'x-item-disabled'). | Component

disabledDates : Array
An array of "dates" to disable, as strings. These strings will be used to build a dynamic regular expression so they ...
An array of "dates" to disable, as strings. These strings will be used to build a dynamic regular expression so they are very powerful. Some examples:

    // disable these exact dates:
    disabledDates: ["03/08/2003", "09/16/2003"]
    // disable these days for every year:
    disabledDates: ["03/08", "09/16"]
    // only match the beginning (useful if you are using short years):
    disabledDates: ["^03/08"]
    // disable every day in March 2006:
    disabledDates: ["03/../2006"]
    // disable every day in every March:
    disabledDates: ["^03"]

Note that the format of the dates included in the array should exactly match the format config. In order to support regular expressions, if you are using a date format that has "." in it, you will have to escape the dot when restricting dates. For example: `["03\\.08\\.03"]`.

DateField

| disabledDatesText : String The tooltip text to display when the date falls on a disabled date (defaults to `'Disabled'`) | DateField

disabledDays : Array
An array of days to disable, 0 based (defaults to null). Some examples:// disable Sunday and Saturday: disabledDays: ...
An array of days to disable, 0 based (defaults to null). Some examples:

    // disable Sunday and Saturday:
    disabledDays:  [0, 6]
    // disable weekdays:
    disabledDays: [1,2,3,4,5]

DateField

| disabledDaysText : String The tooltip to display when the date falls on a disabled day (defaults to `'Disabled'`) | DateField
| editable : Boolean false to prevent the user from typing text directly into the field, the field will only respond to a click on the tri... `false` to prevent the user from typing text directly into the field, the field will only respond to a click on the trigger to set the value. (defaults to `true`). | TriggerField
| emptyClass : String The CSS class to apply to an empty field to style the emptyText (defaults to 'x-form-empty-field'). This class is au... The CSS class to apply to an empty field to style the `emptyText` (defaults to `'x-form-empty-field'`). This class is automatically added and removed as needed depending on the current field value. | TextField
| emptyText : String The default text to place into an empty field (defaults to null). Note: that this value will be submitted to the serv... The default text to place into an empty field (defaults to `null`). Note: that this value will be submitted to the server if this field is enabled and configured with a name. | TextField
| enableKeyEvents : Boolean `true` to enable the proxying of key events for the HTML input field (defaults to `false`) | TextField
| fieldClass : String The default CSS class for the field (defaults to 'x-form-field') | Field

fieldLabel : String
The label text to display next to this Component (defaults to ''). Note: this config is only used when this Component...

The label text to display next to this Component (defaults to '').

Note: this config is only used when this Component is rendered by a Container which has been configured to use the FormLayout layout manager (e.g. Ext.form.FormPanel or specifying `layout:'form'`).

Also see `hideLabel` and Ext.layout.FormLayout.fieldTpl.

Example use:

    new Ext.FormPanel({
        height: 100,
        renderTo: Ext.getBody(),
        items: [{
            xtype: 'textfield',
            fieldLabel: 'Name'
        }]
    });

Component

flex : Number
Note: this config is only used when this Component is rendered by a Container which has been configured to use a BoxL...

Note: this config is only used when this Component is rendered by a Container which has been configured to use a BoxLayout. Each child Component with a `flex` property will be flexed either vertically (by a VBoxLayout) or horizontally (by an HBoxLayout) according to the item's relative `flex` value compared to the sum of all Components with `flex</flex> value specified. Any child items that have either a `flex = 0` or `flex = undefined` will not be 'flexed' (the initial size will not be changed).`

BoxComponent

| focusClass : String The CSS class to use when the field receives focus (defaults to 'x-form-focus') | Field
| format : String The default date format string which can be overriden for localization support. The format must be valid according t... The default date format string which can be overriden for localization support. The format must be valid according to Date.parseDate (defaults to `'m/d/Y'`). | DateField
| height : Number The height of this component in pixels (defaults to auto). Note to express this dimension as a percentage or offset s... The height of this component in pixels (defaults to auto). Note to express this dimension as a percentage or offset see Ext.Component.anchor. | BoxComponent
| hidden : Boolean Render this component hidden (default is false). If `true`, the hide method will be called internally. | Component

hideLabel : Boolean
true to completely hide the label element (label and separator). Defaults to false. By default, even if you do not sp...

`true` to completely hide the label element (label and separator). Defaults to `false`. By default, even if you do not specify a `fieldLabel` the space will still be reserved so that the field will line up with other fields that do have labels. Setting this to `true` will cause the field to not reserve that space.

Note: see the note for `clearCls`.

Example use:

    new Ext.FormPanel({
        height: 100,
        renderTo: Ext.getBody(),
        items: [{
            xtype: 'textfield'
            hideLabel: true
        }]
    });

Component

hideMode : String
How this component should be hidden. Supported values are 'visibility' (css visibility), 'offsets' (negative offset p...

How this component should be hidden. Supported values are `'visibility'` (css visibility), `'offsets'` (negative offset position) and `'display'` (css display).

Note: the default of `'display'` is generally preferred since items are automatically laid out when they are first shown (no sizing is done while hidden).

Component

hideParent : Boolean
True to hide and show the component's container when hide/show is called on the component, false to hide and show the...
True to hide and show the component's container when hide/show is called on the component, false to hide and show the component itself (defaults to false). For example, this can be used as a shortcut for a hide button on a window by setting hide:true on the button when adding it to its parent container.

Component

| hideTrigger : Boolean `true` to hide the trigger element and display only the base text field (defaults to `false`) | TriggerField

html : String/Object
An HTML fragment, or a DomHelper specification to use as the layout element content (defaults to ''). The HTML conten...
An HTML fragment, or a DomHelper specification to use as the layout element content (defaults to ''). The HTML content is added after the component is rendered, so the document will not contain this HTML at the time the render event is fired. This content is inserted into the body before any configured contentEl is appended.

Component

id : String
The unique id of this component (defaults to an auto-assigned id). You should assign an id if you need to be able to ...

The unique id of this component (defaults to an auto-assigned id). You should assign an id if you need to be able to access the component later and you do not have an object reference available (e.g., using Ext.getCmp).

Note that this id will also be used as the element id for the containing HTML element that is rendered to the page for this component. This allows you to write id-based CSS rules to style the specific instance of this component uniquely, and also to select sub-elements using this component's id as the parent.

Note: to avoid complications imposed by a unique `id` also see `itemId` and `ref`.

Note: to access the container of an item see `ownerCt`.

Component

inputType : String
The type attribute for input fields -- e.g. radio, text, password, file (defaults to 'text'). The types 'file' and 'p...
The type attribute for input fields -- e.g. radio, text, password, file (defaults to 'text'). The types 'file' and 'password' must be used to render those field types currently -- there are no separate Ext components for those. Note that if you use `inputType:'file'`, emptyText is not supported and should be avoided.

Field

| invalidClass : String The CSS class to use when marking a field invalid (defaults to 'x-form-invalid') | Field
| invalidText : String The error text to display when the date in the field is invalid (defaults to '{value} is not a valid date - it must b... The error text to display when the date in the field is invalid (defaults to `'{value} is not a valid date - it must be in the format {format}'`). | DateField

itemCls : String
Note: this config is only used when this Component is rendered by a Container which has been configured to use the Fo...

Note: this config is only used when this Component is rendered by a Container which has been configured to use the FormLayout layout manager (e.g. Ext.form.FormPanel or specifying `layout:'form'`).

An additional CSS class to apply to the div wrapping the form item element of this field. If supplied, `itemCls` at the field level will override the default `itemCls` supplied at the container level. The value specified for `itemCls` will be added to the default class (`'x-form-item'`).

Since it is applied to the item wrapper (see Ext.layout.FormLayout.fieldTpl), it allows you to write standard CSS rules that can apply to the field, the label (if specified), or any other element within the markup for the field.

Note: see the note for `fieldLabel`.

Example use:

    // Apply a style to the field's label:
    <style>
        .required .x-form-item-label {font-weight:bold;color:red;}
    </style>

    new Ext.FormPanel({
        height: 100,
        renderTo: Ext.getBody(),
        items: [{
            xtype: 'textfield',
            fieldLabel: 'Name',
            itemCls: 'required' //this label will be styled
        },{
            xtype: 'textfield',
            fieldLabel: 'Favorite Color'
        }]
    });

Component

itemId : String
An itemId can be used as an alternative way to get a reference to a component when no object reference is available. ...

An `itemId` can be used as an alternative way to get a reference to a component when no object reference is available. Instead of using an `id` with Ext.getCmp, use `itemId` with Ext.Container.getComponent which will retrieve `itemId`'s or `id`'s. Since `itemId`'s are an index to the container's internal MixedCollection, the `itemId` is scoped locally to the container -- avoiding potential conflicts with Ext.ComponentMgr which requires a unique `id`.

    var c = new Ext.Panel({ //
        height: 300,
        renderTo: document.body,
        layout: 'auto',
        items: [
            {
                itemId: 'p1',
                title: 'Panel 1',
                height: 150
            },
            {
                itemId: 'p2',
                title: 'Panel 2',
                height: 150
            }
        ]
    })
    p1 = c.getComponent('p1'); // not the same as Ext.getCmp()
    p2 = p1.ownerCt.getComponent('p2'); // reference via a sibling

Also see `id` and `ref`.

Note: to access the container of an item see `ownerCt`.

Component

labelSeparator : String
The separator to display after the text of each fieldLabel. This property may be configured at various levels. The o...

The separator to display after the text of each `fieldLabel`. This property may be configured at various levels. The order of precedence is:

- field / component level
- container level
- layout level (defaults to colon `':'`)

To display no separator for this field's label specify empty string ''.

Note: see the note for `clearCls`.

Also see `hideLabel` and Ext.layout.FormLayout.fieldTpl.

Example use:

    new Ext.FormPanel({
        height: 100,
        renderTo: Ext.getBody(),
        layoutConfig: {
            labelSeparator: '~'   // layout config has lowest priority (defaults to ':')
        },
        labelSeparator: '>>',     // config at container level
        items: [{
            xtype: 'textfield',
            fieldLabel: 'Field 1',
            labelSeparator: '...' // field/component level config supersedes others
        },{
            xtype: 'textfield',
            fieldLabel: 'Field 2' // labelSeparator will be '='
        }]
    });

Component

labelStyle : String
A CSS style specification string to apply directly to this field's label. Defaults to the container's labelStyle val...

A CSS style specification string to apply directly to this field's label. Defaults to the container's labelStyle value if set (e.g., `Ext.layout.FormLayout.labelStyle` , or '').

Note: see the note for `clearCls`.

Also see `hideLabel` and `Ext.layout.FormLayout.fieldTpl.`

Example use:

    new Ext.FormPanel({
        height: 100,
        renderTo: Ext.getBody(),
        items: [{
            xtype: 'textfield',
            fieldLabel: 'Name',
            labelStyle: 'font-weight:bold;'
        }]
    });

Component

listeners : Object
A config object containing one or more event handlers to be added to this object during initialization. This should ...

A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once.

DOM events from ExtJs Components

While some ExtJs Component classes export selected DOM events (e.g. "click", "mouseover" etc), this is usually only done when extra value can be added. For example the DataView's `click` event passing the node clicked on. To access DOM events directly from a Component's HTMLElement, listeners must be added to the Element after the Component has been rendered. A plugin can simplify this step:

    // Plugin is configured with a listeners config object.
    // The Component is appended to the argument list of all handler functions.
    Ext.DomObserver = Ext.extend(Object, {
        constructor: function(config) {
            this.listeners = config.listeners ? config.listeners : config;
        },

        // Component passes itself into plugin's init method
        init: function(c) {
            var p, l = this.listeners;
            for (p in l) {
                if (Ext.isFunction(l[p])) {
                    l[p] = this.createHandler(l[p], c);
                } else {
                    l[p].fn = this.createHandler(l[p].fn, c);
                }
            }

            // Add the listeners to the Element immediately following the render call
            c.render = c.render.createSequence(function() {
                var e = c.getEl();
                if (e) {
                    e.on(l);
                }
            });
        },

        createHandler: function(fn, c) {
            return function(e) {
                fn.call(this, e, c);
            };
        }
    });

    var combo = new Ext.form.ComboBox({

        // Collapse combo when its element is clicked on
        plugins: [ new Ext.DomObserver({
            click: function(evt, comp) {
                comp.collapse();
            }
        })],
        store: myStore,
        typeAhead: true,
        mode: 'local',
        triggerAction: 'all'
    });

Observable

margins : Object
Note: this config is only used when this BoxComponent is rendered by a Container which has been configured to use the...

Note: this config is only used when this BoxComponent is rendered by a Container which has been configured to use the BorderLayout or one of the two BoxLayout subclasses.

An object containing margins to apply to this BoxComponent in the format:

    {
        top: (top margin),
        right: (right margin),
        bottom: (bottom margin),
        left: (left margin)
    }

May also be a string containing space-separated, numeric margin values. The order of the sides associated with each value matches the way CSS processes margin values:

- If there is only one value, it applies to all sides.
- If there are two values, the top and bottom borders are set to the first value and the right and left are set to the second.
- If there are three values, the top is set to the first value, the left and right are set to the second, and the bottom is set to the third.
- If there are four values, they apply to the top, right, bottom, and left, respectively.

Defaults to:

    {top:0, right:0, bottom:0, left:0}

BoxComponent

| maskRe : RegExp An input mask regular expression that will be used to filter keystrokes that do not match (defaults to `null`) | TextField

maxLength : Number
Maximum input field length allowed by validation (defaults to Number.MAX_VALUE). This behavior is intended to provide...
Maximum input field length allowed by validation (defaults to Number.MAX_VALUE). This behavior is intended to provide instant feedback to the user by improving usability to allow pasting and editing or overtyping and back tracking. To restrict the maximum number of characters that can be entered into the field use `autoCreate` to add any attributes you want to a field, for example:

    var myField = new Ext.form.NumberField({
        id: 'mobile',
        anchor:'90%',
        fieldLabel: 'Mobile',
        maxLength: 16, // for validation
        autoCreate: {tag: 'input', type: 'text', size: '20', autocomplete: 'off', maxlength: '10'}
    });

TextField

| maxLengthText : String Error text to display if the maximum length validation fails (defaults to 'The maximum length for this field is {maxL... Error text to display if the `maximum length` validation fails (defaults to `'The maximum length for this field is {maxLength}'`) | TextField
| maxText : String The error text to display when the date in the cell is after maxValue (defaults to 'The date in this field must be be... The error text to display when the date in the cell is after `maxValue` (defaults to `'The date in this field must be before {maxValue}'`). | DateField
| maxValue : Date/String The maximum allowed date. Can be either a Javascript date object or a string date in a valid format (defaults to null... The maximum allowed date. Can be either a Javascript date object or a string date in a valid format (defaults to null). | DateField
| minLength : Number Minimum input field length required (defaults to `0`) | TextField
| minLengthText : String Error text to display if the minimum length validation fails (defaults to 'The minimum length for this field is {minL... Error text to display if the `minimum length` validation fails (defaults to `'The minimum length for this field is {minLength}'`) | TextField
| minText : String The error text to display when the date in the cell is before minValue (defaults to 'The date in this field must be a... The error text to display when the date in the cell is before `minValue` (defaults to `'The date in this field must be after {minValue}'`). | DateField
| minValue : Date/String The minimum allowed date. Can be either a Javascript date object or a string date in a valid format (defaults to null... The minimum allowed date. Can be either a Javascript date object or a string date in a valid format (defaults to null). | DateField
| msgFx : String Experimental The effect used when displaying a validation message under the field (defaults to 'normal'). | Field

msgTarget : String
The location where the message text set through markInvalid should display. Must be one of the following values: <div...

The location where the message text set through markInvalid should display. Must be one of the following values:

- `qtip` Display a quick tip containing the message when the user hovers over the field. This is the default.
  Ext.QuickTips.init must have been called for this setting to work.</div</li>
- `title` Display the message in a default browser title attribute popup.
- `under` Add a block div beneath the field containing the error message.
- `side` Add an error icon to the right of the field, displaying the message in a popup on hover.
- `[element id]` Add the error message directly to the innerHTML of the specified element.

Field

| name : String The field's HTML name attribute (defaults to ''). Note: this property must be set if this field is to be automaticall... The field's HTML name attribute (defaults to ''). Note: this property must be set if this field is to be automatically included with form submit(). | Field

overCls : String
An optional extra CSS class that will be added to this component's Element when the mouse moves over the Element, and...
An optional extra CSS class that will be added to this component's Element when the mouse moves over the Element, and removed when the mouse moves out. (defaults to ''). This can be useful for adding customized 'active' or 'hover' styles to the component or any of its children using standard CSS rules.

Component

| pageX : Number The page level x coordinate for this component if contained within a positioning container. | BoxComponent
| pageY : Number The page level y coordinate for this component if contained within a positioning container. | BoxComponent

plugins : Object/Array
An object or array of objects that will provide custom functionality for this component. The only requirement for a ...
An object or array of objects that will provide custom functionality for this component. The only requirement for a valid plugin is that it contain an init method that accepts a reference of type Ext.Component. When a component is created, if any plugins are available, the component will call the init method on each plugin, passing a reference to itself. Each plugin can then call methods or respond to events on the component as needed to provide its functionality.

Component

| preventMark : Boolean `true` to disable marking the field invalid. Defaults to `false`. | Field

ptype : String
The registered ptype to create. This config option is not used when passing a config object into a constructor. This ...
The registered `ptype` to create. This config option is not used when passing a config object into a constructor. This config option is used only when lazy instantiation is being used, and a Plugin is being specified not as a fully instantiated Component, but as a Component config object. The `ptype` will be looked up at render time up to determine what type of Plugin to create.
If you create your own Plugins, you may register them using Ext.ComponentMgr.registerPlugin in order to be able to take advantage of lazy instantiation and rendering.

Component

| readOnly : Boolean true to prevent the user from changing the field, and hides the trigger. Superceeds the editable and hideTrigger opt... `true` to prevent the user from changing the field, and hides the trigger. Superceeds the editable and hideTrigger options if the value is true. (defaults to `false`) | TriggerField

ref : String
A path specification, relative to the Component's ownerCt specifying into which ancestor Container to place a named r...

A path specification, relative to the Component's `ownerCt` specifying into which ancestor Container to place a named reference to this Component.

The ancestor axis can be traversed by using '/' characters in the path. For example, to put a reference to a Toolbar Button into the Panel which owns the Toolbar:

    var myGrid = new Ext.grid.EditorGridPanel({
        title: 'My EditorGridPanel',
        store: myStore,
        colModel: myColModel,
        tbar: [{
            text: 'Save',
            handler: saveChanges,
            disabled: true,
            ref: '../saveButton'
        }],
        listeners: {
            afteredit: function() {
    //          The button reference is in the GridPanel
                myGrid.saveButton.enable();
            }
        }
    });

In the code above, if the `ref` had been `'saveButton'` the reference would have been placed into the Toolbar. Each '/' in the `ref` moves up one level from the Component's `ownerCt`.

Also see the `added` and `removed` events.

Component

| regex : RegExp A JavaScript RegExp object to be tested against the field value during validation (defaults to null). If the test fai... A JavaScript RegExp object to be tested against the field value during validation (defaults to `null`). If the test fails, the field will be marked invalid using `regexText`. | TextField
| regexText : String The error text to display if `regex` is used and the test fails during validation (defaults to `''`) | TextField
| region : String Note: this config is only used when this BoxComponent is rendered by a Container which has been configured to use the... Note: this config is only used when this BoxComponent is rendered by a Container which has been configured to use the BorderLayout layout manager (e.g. specifying `layout:'border'`). See Ext.layout.BorderLayout also. | BoxComponent

renderTo : Mixed
Specify the id of the element, a DOM element or an existing Element that this component will be rendered into. Notes ...

Specify the id of the element, a DOM element or an existing Element that this component will be rendered into.

- Notes :
  Do not use this option if the Component is to be a child item of a Container. It is the responsibility of the Container's layout manager to render and manage its child items.
  When using this config, a call to render() is not required.

See `render` also.

Component

| selectOnFocus : Boolean `true` to automatically select any existing field text when the field receives input focus (defaults to `false`) | TextField
| showToday : Boolean false to hide the footer area of the DatePicker containing the Today button and disable the keyboard handler for spac... `false` to hide the footer area of the DatePicker containing the Today button and disable the keyboard handler for spacebar that selects the current date (defaults to `true`). | DateField
| startDay : Number Day index at which the week should begin, 0-based (defaults to 0, which is Sunday) | DateField

stateEvents : Array
An array of events that, when fired, should trigger this component to save its state (defaults to none). stateEvents ...

An array of events that, when fired, should trigger this component to save its state (defaults to none). `stateEvents` may be any type of event supported by this component, including browser or custom events (e.g., `['click', 'customerchange']`).

See `stateful` for an explanation of saving and restoring Component state.

Component

| stateId : String The unique id for this component to use for state management purposes (defaults to the component id if one was set, o... The unique id for this component to use for state management purposes (defaults to the component id if one was set, otherwise null if the component is using a generated id). See `stateful` for an explanation of saving and restoring Component state. | Component

stateful : Boolean
A flag which causes the Component to attempt to restore the state of internal properties from a saved state on startu...

A flag which causes the Component to attempt to restore the state of internal properties from a saved state on startup. The component must have either a `stateId` or `id` assigned for state to be managed. Auto-generated ids are not guaranteed to be stable across page loads and cannot be relied upon to save and restore the same state for a component.

For state saving to work, the state manager's provider must have been set to an implementation of Ext.state.Provider which overrides the set and get methods to save and recall name/value pairs. A built-in implementation, Ext.state.CookieProvider is available.

To set the state provider for the current page:

    Ext.state.Manager.setProvider(new Ext.state.CookieProvider({
        expires: new Date(new Date().getTime()+(1000*60*60*24*7)), //7 days from now
    }));

A stateful Component attempts to save state when one of the events listed in the `stateEvents` configuration fires.

To save state, a stateful Component first serializes its state by calling `getState`. By default, this function does nothing. The developer must provide an implementation which returns an object hash which represents the Component's restorable state.

The value yielded by getState is passed to Ext.state.Manager.set which uses the configured Ext.state.Provider to save the object keyed by the Component's `stateId`, or, if that is not specified, its `id`.

During construction, a stateful Component attempts to restore its state by calling Ext.state.Manager.get passing the `stateId`, or, if that is not specified, the `id`.

The resulting object is passed to `applyState`. The default implementation of `applyState` simply copies properties into the object, but a developer may override this to support more behaviour.

You can perform extra processing on state save and restore by attaching handlers to the beforestaterestore, staterestore, beforestatesave and statesave events.

Component

| stripCharsRe : RegExp A JavaScript RegExp object used to strip unwanted content from the value before validation (defaults to `null`). | TextField

style : String
A custom style specification to be applied to this component's Element. Should be a valid argument to Ext.Element.ap...
A custom style specification to be applied to this component's Element. Should be a valid argument to Ext.Element.applyStyles.

    new Ext.Panel({
        title: 'Some Title',
        renderTo: Ext.getBody(),
        width: 400, height: 300,
        layout: 'form',
        items: [{
            xtype: 'textarea',
            style: {
                width: '95%',
                marginBottom: '10px'
            }
        },
            new Ext.Button({
                text: 'Send',
                minWidth: '100',
                style: {
                    marginBottom: '10px'
                }
            })
        ]
    });

Component

| submitValue : Boolean False to clear the name attribute on the field so that it is not submitted during a form post. Defaults to `true`. | Field
| tabIndex : Number The tabIndex for this field. Note this only applies to fields that are rendered, not those which are built via applyT... The tabIndex for this field. Note this only applies to fields that are rendered, not those which are built via applyTo (defaults to undefined). | Field

tabTip : String
Note: this config is only used when this BoxComponent is a child item of a TabPanel. A string to be used as innerHTML...

Note: this config is only used when this BoxComponent is a child item of a TabPanel.

A string to be used as innerHTML (html tags are accepted) to show in a tooltip when mousing over the associated tab selector element. Ext.QuickTips.init() must be called in order for the tips to render.

BoxComponent

| tpl : Mixed An Ext.Template, Ext.XTemplate or an array of strings to form an Ext.XTemplate. Used in conjunction with the data and... An <bold>Ext.Template</bold>, <bold>Ext.XTemplate</bold> or an array of strings to form an Ext.XTemplate. Used in conjunction with the `data` and `tplWriteMode` configurations. | Component
| tplWriteMode : String The Ext.(X)Template method to use when updating the content area of the Component. Defaults to 'overwrite' (see Ext.X... The Ext.(X)Template method to use when updating the content area of the Component. Defaults to `'overwrite'` (see `Ext.XTemplate.overwrite`). | Component
| triggerClass : String An additional CSS class used to style the trigger button. The trigger will always get the class 'x-form-trigger' and... An additional CSS class used to style the trigger button. The trigger will always get the class `'x-form-trigger'` and `triggerClass` will be appended if specified (defaults to `'x-form-date-trigger'` which displays a calendar icon). | DateField

triggerConfig : Mixed
A DomHelper config object specifying the structure of the trigger element for this Field. (Optional). Specify this wh...

A DomHelper config object specifying the structure of the trigger element for this Field. (Optional).

Specify this when you need a customized element to act as the trigger button for a TriggerField.

Note that when using this option, it is the developer's responsibility to ensure correct sizing, positioning and appearance of the trigger. Defaults to:

    {tag: "img", src: Ext.BLANK_IMAGE_URL, cls: "x-form-trigger " + this.triggerClass}

TriggerField

| validateOnBlur : Boolean Whether the field should validate when it loses focus (defaults to true). | Field
| validationDelay : Number The length of time in milliseconds after user input begins until validation is initiated (defaults to 250) | Field
| validationEvent : String/Boolean The event that should initiate field validation. Set to false to disable automatic validation (defaults to 'key... The event that should initiate field validation. Set to false to disable automatic validation (defaults to 'keyup'). | Field

validator : Function
A custom validation function to be called during field validation (validateValue) (defaults to null). If specified, t...

A custom validation function to be called during field validation (validateValue) (defaults to `null`). If specified, this function will be called first, allowing the developer to override the default validation process.

This function will be passed the following Parameters:

- `value`: Mixed
  The current field value

This function is to Return:

- `true`: Boolean
  `true` if the value is valid
- `msg`: String
  An error message if the value is invalid

TextField

| value : Mixed A value to initialize this field with (defaults to undefined). | Field
| vtype : String A validation type name as defined in Ext.form.VTypes (defaults to `null`) | TextField
| vtypeText : String A custom error message to display in place of the default message provided for the vtype currently set for this field... A custom error message to display in place of the default message provided for the `vtype` currently set for this field (defaults to `''`). Note: only applies if `vtype` is set, else ignored. | TextField
| width : Number The width of this component in pixels (defaults to auto). Note to express this dimension as a percentage or offset se... The width of this component in pixels (defaults to auto). Note to express this dimension as a percentage or offset see Ext.Component.anchor. | BoxComponent
| wrapFocusClass : String The class added to the to the wrap of the trigger element. Defaults to `x-trigger-wrap-focus`. | TriggerField
| x : Number The local x (left) coordinate for this component if contained within a positioning container. | BoxComponent

xtype : String
The registered xtype to create. This config option is not used when passing a config object into a constructor. This ...
The registered `xtype` to create. This config option is not used when passing a config object into a constructor. This config option is used only when lazy instantiation is being used, and a child item of a Container is being specified not as a fully instantiated Component, but as a Component config object. The `xtype` will be looked up at render time up to determine what type of child Component to create.
The predefined xtypes are listed here.
If you subclass Components to create your own Components, you may register them using Ext.ComponentMgr.registerType in order to be able to take advantage of lazy instantiation and rendering.

Component

| y : Number The local y (top) coordinate for this component if contained within a positioning container. | BoxComponent

## Public Properties

Property | Defined By
--- | ---
| disabled : Boolean True if this component is disabled. Read-only. | Component

el : Ext.Element
The Ext.Element which encapsulates this Component. Read-only. This will usually be a &lt;DIV> element created by the ...

The Ext.Element which encapsulates this Component. Read-only.

This will usually be a <DIV> element created by the class's onRender method, but that may be overridden using the `autoEl` config.

Note: this element will not be available until this Component has been rendered.

To add listeners for DOM events to this Component (as opposed to listeners for this Component's own Observable events), see the listeners config for a suggestion, or use a render listener directly:

    new Ext.Panel({
        title: 'The Clickable Panel',
        listeners: {
            render: function(p) {
                // Append the Panel to the click handler's argument list.
                p.getEl().on('click', handlePanelClick.createDelegate(null, [p], true));
            },
            single: true  // Remove the listener after first invocation
        }
    });

See also `getEl`

Component

| hidden : Boolean True if this component is hidden. Read-only. | Component
| initialConfig : Object This Component's initial configuration specification. Read-only. | Component
| label : Ext.Element The label Element associated with this Field. Only available after this Field has been rendered by a Ext.layout.FormL... The label Element associated with this Field. Only available after this Field has been rendered by a Ext.layout.FormLayout layout manager. | Field
| originalValue : mixed The original value of the field as configured in the value configuration, or as loaded by the last form load operatio... The original value of the field as configured in the value configuration, or as loaded by the last form load operation if the form's trackResetOnLoad setting is `true`. | Field
| ownerCt : Ext.Container This Component's owner Container (defaults to undefined, and is set automatically when this Component is added to a C... This Component's owner Container (defaults to undefined, and is set automatically when this Component is added to a Container). Read-only. Note: to access items within the Container see `itemId`. | Component
| refOwner : Ext.Container The ancestor Container into which the ref reference was inserted if this Component is a child of a Container, and has... The ancestor Container into which the ref reference was inserted if this Component is a child of a Container, and has been configured with a `ref`. | Component
| rendered : Boolean True if this component has been rendered. Read-only. | Component

startValue : mixed
The value that the Field had at the time it was last focused. This is the value that is passed to the change event wh...

The value that the Field had at the time it was last focused. This is the value that is passed to the change event which is fired if the value has been changed when the Field is blurred.

This will be undefined until the Field has been visited. Compare originalValue.

Field

## Public Methods

Method | Defined By
--- | ---

DateField( `Object config` )
Create a new DateField
Create a new DateField
Parameters:

- `config` : Object

Returns:

- void

DateField

addClass( `string cls` ) : Ext.Component
Adds a CSS class to the component's underlying element.
Adds a CSS class to the component's underlying element.
Parameters:

- `cls` : string
  The CSS class name to add

Returns:

- `Ext.Component`
  this

Component

addEvents( `Object|String o`, `string Optional.` ) : void
Adds the specified events to the list of events which this Observable may fire.
Adds the specified events to the list of events which this Observable may fire.
Parameters:

- `o` : Object|String
  Either an object with event names as properties with a value of `true` or the first event name string if multiple event names are being passed as separate parameters.
- `Optional.` : string
  Event name if multiple event names are being passed as separate parameters. Usage:

      this.addEvents('storeloaded', 'storecleared');

Returns:

- void

Observable

addListener( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this object.
Appends an event handler to this object.
Parameters:

- `eventName` : String
  The name of the event to listen for.
- `handler` : Function
  The method the event invokes.
- `scope` : Object
  (optional) The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
- `options` : Object
  (optional) An object containing handler configuration. properties. This may contain any of the following properties:
  - scope : Object
    The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
  - delay : Number
    The number of milliseconds to delay the invocation of the handler after the event fires.
  - single : Boolean
    True to add a handler to handle just the next firing of the event, and then remove itself.
  - buffer : Number
    Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.
  - target : Observable
    Only call the handler if the event was fired on the target Observable, not if the event was bubbled up from a child Observable.

  Combining Options
  Using the options argument, it is possible to combine different types of listeners:
  A delayed, one-time listener.

      myDataView.on('click', this.onClick, this, {
      single: true,
      delay: 100
      });

  Attaching multiple handlers in 1 call
  The method also allows for a single argument to be passed which is a config object containing properties which specify multiple handlers.

      myGridPanel.on({
      'click' : {
          fn: this.onClick,
          scope: this,
          delay: 100
      },
      'mouseover' : {
          fn: this.onMouseOver,
          scope: this
      },
      'mouseout' : {
          fn: this.onMouseOut,
          scope: this
      }
      });

  Or a shorthand syntax:

      myGridPanel.on({
      'click' : this.onClick,
      'mouseover' : this.onMouseOver,
      'mouseout' : this.onMouseOut,
       scope: this
      });

Returns:

- void

Observable

applyToMarkup( `String/HTMLElement el` ) : void
Apply this component to existing markup that is valid. With this function, no call to render() is required.
Apply this component to existing markup that is valid. With this function, no call to render() is required.
Parameters:

- `el` : String/HTMLElement

Returns:

- void

Component

bubble( `Function fn`, [`Object scope`], [`Array args`] ) : Ext.Component
Bubbles up the component/container heirarchy, calling the specified function with each component. The scope (this) of...
Bubbles up the component/container heirarchy, calling the specified function with each component. The scope (this) of function call will be the scope provided or the current component. The arguments to the function will be the args provided or the current component. If the function returns false at any point, the bubble is stopped.
Parameters:

- `fn` : Function
  The function to call
- `scope` : Object
  (optional) The scope of the function (defaults to current node)
- `args` : Array
  (optional) The args to call the function with (default to passing the current component)

Returns:

- `Ext.Component`
  this

Component

clearInvalid() : void
Clear any invalid styles/messages for this field
Clear any invalid styles/messages for this field
Parameters:

- None.

Returns:

- void

Field

cloneConfig( `Object overrides` ) : Ext.Component
Clone the current component using the original config values passed into this instance by default.
Clone the current component using the original config values passed into this instance by default.
Parameters:

- `overrides` : Object
  A new config containing any properties to override in the cloned version. An id property can be passed on this object, otherwise one will be generated to avoid duplicates.

Returns:

- `Ext.Component`
  clone The cloned copy of this component

Component

destroy() : void
Destroys this component by purging any event listeners, removing the component's element from the DOM, removing the c...
Destroys this component by purging any event listeners, removing the component's element from the DOM, removing the component from its Ext.Container (if applicable) and unregistering it from Ext.ComponentMgr. Destruction is generally handled automatically by the framework and this method should usually not need to be called directly.
Parameters:

- None.

Returns:

- void

Component

disable() : Ext.Component
Disable this component and fire the 'disable' event.
Disable this component and fire the 'disable' event.
Parameters:

- None.

Returns:

- `Ext.Component`
  this

Component

enable() : Ext.Component
Enable this component and fire the 'enable' event.
Enable this component and fire the 'enable' event.
Parameters:

- None.

Returns:

- `Ext.Component`
  this

Component

enableBubble( `String/Array events` ) : void
Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if present....

Enables events fired by this Observable to bubble up an owner hierarchy by calling `this.getBubbleTarget()` if present. There is no implementation in the Observable base class.

This is commonly used by Ext.Components to bubble events to owner Containers. See Ext.Component.getBubbleTarget. The default implementation in Ext.Component returns the Component's immediate owner. But if a known target is required, this can be overridden to access the required target more quickly.

Example:

    Ext.override(Ext.form.Field, {
        //  Add functionality to Field's initComponent to enable the change event to bubble
        initComponent : Ext.form.Field.prototype.initComponent.createSequence(function() {
            this.enableBubble('change');
        }),

        //  We know that we want Field's events to bubble directly to the FormPanel.
        getBubbleTarget : function() {
            if (!this.formPanel) {
                this.formPanel = this.findParentByType('form');
            }
            return this.formPanel;
        }
    });

    var myForm = new Ext.formPanel({
        title: 'User Details',
        items: [{
            ...
        }],
        listeners: {
            change: function() {
                // Title goes red if form has been modified.
                myForm.header.setStyle('color', 'red');
            }
        }
    });

Parameters:

- `events` : String/Array
  The event name to bubble, or an Array of event names.

Returns:

- void

Observable

findParentBy( `Function fn` ) : Ext.Container
Find a container above this component at any level by a custom function. If the passed function returns true, the con...
Find a container above this component at any level by a custom function. If the passed function returns true, the container will be returned.
Parameters:

- `fn` : Function
  The custom function to call with the arguments (container, this component).

Returns:

- `Ext.Container`
  The first Container for which the custom function returns true

Component

findParentByType( `String/Ext.Component/Class xtype`, [`Boolean shallow`] ) : Ext.Container
Find a container above this component at any level by xtype or class
Find a container above this component at any level by xtype or class
Parameters:

- `xtype` : String/Ext.Component/Class
  The xtype to check for this Component. Note that the the component can either be an instance or a component class:
- `shallow` : Boolean
  (optional) False to check whether this Component is descended from the xtype (this is the default), or true to check whether this Component is directly of the specified xtype.

Returns:

- `Ext.Container`
  The first Container which matches the given xtype or class

Component

fireEvent( `String eventName`, `Object... args` ) : Boolean
Fires the specified event with the passed parameters (minus the event name). An event may be set to bubble up an Obse...

Fires the specified event with the passed parameters (minus the event name).

An event may be set to bubble up an Observable parent hierarchy (See Ext.Component.getBubbleTarget) by calling enableBubble.

Parameters:

- `eventName` : String
  The name of the event to fire.
- `args` : Object...
  Variable number of parameters are passed to handlers.

Returns:

- `Boolean`
  returns false if any of the handlers return false otherwise it returns true.

Observable

focus( [`Boolean selectText`], [`Boolean/Number delay`] ) : Ext.Component
Try to focus this component.
Try to focus this component.
Parameters:

- `selectText` : Boolean
  (optional) If applicable, true to also select the text in this component
- `delay` : Boolean/Number
  (optional) Delay the focus this number of milliseconds (true for 10 milliseconds)

Returns:

- `Ext.Component`
  this

Component

getActiveError() : String
Gets the active error message for this field.
Gets the active error message for this field.
Parameters:

- None.

Returns:

- `String`
  Returns the active error message on the field, if there is no error, an empty string is returned.

Field

getBox( [`Boolean local`] ) : Object
Gets the current box measurements of the component's underlying element.
Gets the current box measurements of the component's underlying element.
Parameters:

- `local` : Boolean
  (optional) If true the element's left and top are returned instead of page XY (defaults to false)

Returns:

- `Object`
  box An object in the format {x, y, width, height}

BoxComponent

getBubbleTarget() : Ext.Container
Provides the link for Observable's fireEvent method to bubble up the ownership hierarchy.
Provides the link for Observable's fireEvent method to bubble up the ownership hierarchy.
Parameters:

- None.

Returns:

- `Ext.Container`
  the Container which owns this Component.

Component

getEl() : Ext.Element
Returns the Ext.Element which encapsulates this Component. This will usually be a &lt;DIV> element created by the cla...

Returns the Ext.Element which encapsulates this Component.

This will usually be a <DIV> element created by the class's onRender method, but that may be overridden using the autoEl config.

Note: this element will not be available until this Component has been rendered.

To add listeners for DOM events to this Component (as opposed to listeners for this Component's own Observable events), see the listeners config for a suggestion, or use a render listener directly:

    new Ext.Panel({
        title: 'The Clickable Panel',
        listeners: {
            render: function(p) {
                // Append the Panel to the click handler's argument list.
                p.getEl().on('click', handlePanelClick.createDelegate(null, [p], true));
            },
            single: true  // Remove the listener after first invocation
        }
    });

Parameters:

- None.

Returns:

- `Ext.Element`
  The Element which encapsulates this Component.

Component

getErrors( `Mixed value` ) : Array
Runs all of NumberFields validations and returns an array of any errors. Note that this first runs TextField's valida...
Runs all of NumberFields validations and returns an array of any errors. Note that this first runs TextField's validations, so the returned array is an amalgamation of all field errors. The additional validation checks are testing that the date format is valid, that the chosen date is within the min and max date constraints set, that the date chosen is not in the disabledDates regex and that the day chosed is not one of the disabledDays.
Parameters:

- `value` : Mixed
  The value to get errors for (defaults to the current field value)

Returns:

- `Array`
  All validation errors for this field

DateField

getHeight() : Number
Gets the current height of the component's underlying element.
Gets the current height of the component's underlying element.
Parameters:

- None.

Returns:

- `Number`

BoxComponent

getId() : String
Returns the id of this component or automatically generates and returns an id if an id is not defined yet:'ext-comp-'...
Returns the `id` of this component or automatically generates and returns an `id` if an `id` is not defined yet:

    'ext-comp-' + (++Ext.Component.AUTO_ID)

Parameters:

- None.

Returns:

- `String`
  id

Component

getItemId() : String
Returns the itemId of this component. If an itemId was not assigned through configuration the id is returned using g...
Returns the `itemId` of this component. If an `itemId` was not assigned through configuration the `id` is returned using `getId`.
Parameters:

- None.

Returns:

- `String`

Component

getName() : String
Returns the name or hiddenName attribute of the field if available.
Returns the name or hiddenName attribute of the field if available.
Parameters:

- None.

Returns:

- `String`
  name The field {@link Ext.form.Field#name name} or {@link Ext.form.ComboBox#hiddenName hiddenName}

Field

getOuterSize() : Object
Gets the current size of the component's underlying element, including space taken by its margins.
Gets the current size of the component's underlying element, including space taken by its margins.
Parameters:

- None.

Returns:

- `Object`
  An object containing the element's size {width: (element width + left/right margins), height: (element height + top/bottom margins)}

BoxComponent

getPosition( [`Boolean local`] ) : Array
Gets the current XY position of the component's underlying element.
Gets the current XY position of the component's underlying element.
Parameters:

- `local` : Boolean
  (optional) If true the element's left and top are returned instead of page XY (defaults to false)

Returns:

- `Array`
  The XY position of the element (e.g., [100, 200])

BoxComponent

getRawValue() : Mixed
Returns the raw data value which may or may not be a valid, defined value. To return a normalized value see getValue...
Returns the raw data value which may or may not be a valid, defined value. To return a normalized value see getValue.
Parameters:

- None.

Returns:

- `Mixed`
  value The field value

Field

getResizeEl() : Ext.Element
Returns the outermost Element of this Component which defines the Components overall size. Usually this will return t...

Returns the outermost Element of this Component which defines the Components overall size.

Usually this will return the same Element as `getEl`, but in some cases, a Component may have some more wrapping Elements around its main active Element.

An example is a ComboBox. It is encased in a wrapping Element which contains both the `<input>` Element (which is what would be returned by its `getEl` method, and the trigger button Element. This Element is returned as the `resizeEl`.

Parameters:

- None.

Returns:

- `Ext.Element`
  The Element which is to be resized by size managing layouts.

BoxComponent

getSize() : Object
Gets the current size of the component's underlying element.
Gets the current size of the component's underlying element.
Parameters:

- None.

Returns:

- `Object`
  An object containing the element's size {width: (element width), height: (element height)}

BoxComponent

getValue() : Date
Returns the current date value of the date field.
Returns the current date value of the date field.
Parameters:

- None.

Returns:

- `Date`
  The date value

DateField

getWidth() : Number
Gets the current width of the component's underlying element.
Gets the current width of the component's underlying element.
Parameters:

- None.

Returns:

- `Number`

BoxComponent

getXType() : String
Gets the xtype for this component as registered with Ext.ComponentMgr. For a list of all available xtypes, see the Ex...
Gets the xtype for this component as registered with Ext.ComponentMgr. For a list of all available xtypes, see the Ext.Component header. Example usage:

    var t = new Ext.form.TextField();
    alert(t.getXType());  // alerts 'textfield'

Parameters:

- None.

Returns:

- `String`
  The xtype

Component

getXTypes() : String
Returns this Component's xtype hierarchy as a slash-delimited string. For a list of all available xtypes, see the Ext...

Returns this Component's xtype hierarchy as a slash-delimited string. For a list of all available xtypes, see the Ext.Component header.

If using your own subclasses, be aware that a Component must register its own xtype to participate in determination of inherited xtypes.

Example usage:

    var t = new Ext.form.TextField();
    alert(t.getXTypes());  // alerts 'component/box/field/textfield'

Parameters:

- None.

Returns:

- `String`
  The xtype hierarchy string

Component

hasListener( `String eventName` ) : Boolean
Checks to see if this object has any listeners for a specified event
Checks to see if this object has any listeners for a specified event
Parameters:

- `eventName` : String
  The name of the event to check for

Returns:

- `Boolean`
  True if the event is being listened for, else false

Observable

hide() : Ext.Component
Hide this component. Listen to the 'beforehide' event and return false to cancel hiding the component. Fires the 'h...
Hide this component. Listen to the 'beforehide' event and return `false` to cancel hiding the component. Fires the 'hide' event after hiding the component. Note this method is called internally if the component is configured to be `hidden`.
Parameters:

- None.

Returns:

- `Ext.Component`
  this

Component

isDirty() : Boolean
Returns true if the value of this Field has been changed from its original value. Will return false if the field is d...

Returns true if the value of this Field has been changed from its original value. Will return false if the field is disabled or has not been rendered yet.

Note that if the owning form was configured with Ext.form.BasicForm.trackResetOnLoad then the original value is updated when the values are loaded by Ext.form.BasicForm.setValues.

Parameters:

- None.

Returns:

- `Boolean`
  True if this field has been changed from its original value (and is not disabled), false otherwise.

Field

isValid( `Boolean preventMark` ) : Boolean
Returns whether or not the field value is currently valid by validating the processed value of the field. Note: disab...
Returns whether or not the field value is currently valid by validating the processed value of the field. Note: disabled fields are ignored.
Parameters:

- `preventMark` : Boolean
  True to disable marking the field invalid

Returns:

- `Boolean`
  True if the value is valid, else false

Field

isVisible() : Boolean
Returns true if this component is visible.
Returns true if this component is visible.
Parameters:

- None.

Returns:

- `Boolean`
  True if this component is visible, false otherwise.

Component

isXType( `String/Ext.Component/Class xtype`, [`Boolean shallow`] ) : Boolean
Tests whether or not this Component is of a specific xtype. This can test whether this Component is descended from th...

Tests whether or not this Component is of a specific xtype. This can test whether this Component is descended from the xtype (default) or whether it is directly of the xtype specified (shallow = true).

If using your own subclasses, be aware that a Component must register its own xtype to participate in determination of inherited xtypes.

For a list of all available xtypes, see the Ext.Component header.

Example usage:

    var t = new Ext.form.TextField();
    var isText = t.isXType('textfield');        // true
    var isBoxSubclass = t.isXType('box');       // true, descended from BoxComponent
    var isBoxInstance = t.isXType('box', true); // false, not a direct BoxComponent instance

Parameters:

- `xtype` : String/Ext.Component/Class
  The xtype to check for this Component. Note that the the component can either be an instance or a component class:

      var c = new Ext.Component();
      console.log(c.isXType(c));
      console.log(c.isXType(Ext.Component));

- `shallow` : Boolean
  (optional) False to check whether this Component is descended from the xtype (this is the default), or true to check whether this Component is directly of the specified xtype.

Returns:

- `Boolean`
  True if this component descends from the specified xtype, false otherwise.

Component

markInvalid( [`String msg`] ) : void
Display an error message associated with this field, using msgTarget to determine how to display the message and appl...

Display an error message associated with this field, using msgTarget to determine how to display the message and applying invalidClass to the field's UI element.

Note: this method does not cause the Field's validate method to return `false` if the value does pass validation. So simply marking a Field as invalid will not prevent submission of forms submitted with the Ext.form.Action.Submit.clientValidation option set.

invalid.
Parameters:

- `msg` : String
  (optional) The validation message (defaults to invalidText)

Returns:

- void

Field

mon( `Observable|Element item`, `Object|String ename`, `Function fn`, `Object scope`, `Object opt` ) : void
Adds listeners to any Observable object (or Elements) which are automatically removed when this Component is destroye...

Adds listeners to any Observable object (or Elements) which are automatically removed when this Component is destroyed. Usage:

`

    myGridPanel.mon(myGridPanel.getSelectionModel(), 'selectionchange', handleSelectionChange, null, {buffer: 50});

`

or:

`

    myGridPanel.mon(myGridPanel.getSelectionModel(), {
        selectionchange: handleSelectionChange,
        buffer: 50
    });

`
Parameters:

- `item` : Observable|Element
  The item to which to add a listener/listeners.
- `ename` : Object|String
  The event name, or an object containing event name properties.
- `fn` : Function
  Optional. If the `ename` parameter was an event name, this is the handler function.
- `scope` : Object
  Optional. If the `ename` parameter was an event name, this is the scope (`this` reference) in which the handler function is executed.
- `opt` : Object
  Optional. If the `ename` parameter was an event name, this is the addListener options.

Returns:

- void

Component

mun( `Observable|Element item`, `Object|String ename`, `Function fn`, `Object scope` ) : void
Removes listeners that were added by the mon method.
Removes listeners that were added by the mon method.
Parameters:

- `item` : Observable|Element
  The item from which to remove a listener/listeners.
- `ename` : Object|String
  The event name, or an object containing event name properties.
- `fn` : Function
  Optional. If the `ename` parameter was an event name, this is the handler function.
- `scope` : Object
  Optional. If the `ename` parameter was an event name, this is the scope (`this` reference) in which the handler function is executed.

Returns:

- void

Component

nextSibling() : Ext.Component
Returns the next component in the owning container
Returns the next component in the owning container
Parameters:

- None.

Returns:

- `Ext.Component`

Component

on( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this object (shorthand for addListener.)
Appends an event handler to this object (shorthand for addListener.)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
- `options` : Object
  (optional) An object containing handler configuration.

Returns:

- void

Observable

previousSibling() : Ext.Component
Returns the previous component in the owning container
Returns the previous component in the owning container
Parameters:

- None.

Returns:

- `Ext.Component`

Component

processValue( `Mixed value` ) : void
This method should only be overridden if necessary to prepare raw values for validation (see validate and isValid). ...
This method should only be overridden if necessary to prepare raw values for validation (see validate and isValid). This method is expected to return the processed value for the field which will be used for validation (see validateValue method).
Parameters:

- `value` : Mixed

Returns:

- void

Field

purgeListeners() : void
Removes all listeners for this object
Removes all listeners for this object
Parameters:

- None.

Returns:

- void

Observable

relayEvents( `Object o`, `Array events` ) : void
Relays selected events from the specified Observable as if the events were fired by this.
Relays selected events from the specified Observable as if the events were fired by `this`.
Parameters:

- `o` : Object
  The Observable whose events this object is to relay.
- `events` : Array
  Array of event names to relay.

Returns:

- void

Observable

removeClass( `string cls` ) : Ext.Component
Removes a CSS class from the component's underlying element.
Removes a CSS class from the component's underlying element.
Parameters:

- `cls` : string
  The CSS class name to remove

Returns:

- `Ext.Component`
  this

Component

removeListener( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes an event handler.
Removes an event handler.
Parameters:

- `eventName` : String
  The type of event the handler was associated with.
- `handler` : Function
  The handler to remove. This must be a reference to the function passed into the addListener call.
- `scope` : Object
  (optional) The scope originally specified for the handler.

Returns:

- void

Observable

render( [`Element/HTMLElement/String container`], [`String/Number position`] ) : void
Render this Component into the passed HTML element. If you are using a Container object to house this Component, then...

Render this Component into the passed HTML element.

If you are using a Container object to house this Component, then do not use the render method.

A Container's child Components are rendered by that Container's layout manager when the Container is first rendered.

Certain layout managers allow dynamic addition of child components. Those that do include Ext.layout.CardLayout, Ext.layout.AnchorLayout, Ext.layout.FormLayout, Ext.layout.TableLayout.

If the Container is already rendered when a new child Component is added, you may need to call the Container's doLayout to refresh the view which causes any unrendered child Components to be rendered. This is required so that you can add multiple child components if needed while only refreshing the layout once.

When creating complex UIs, it is important to remember that sizing and positioning of child items is the responsibility of the Container's layout manager. If you expect child items to be sized in response to user interactions, you must configure the Container with a layout manager which creates and manages the type of layout you have in mind.

Omitting the Container's layout config means that a basic layout manager is used which does nothing but render child components sequentially into the Container. No sizing or positioning will be performed in this situation.

Parameters:

- `container` : Element/HTMLElement/String
  (optional) The element this Component should be rendered into. If it is being created from existing markup, this should be omitted.
- `position` : String/Number
  (optional) The element ID or DOM node index within the container before which this component will be inserted (defaults to appending to the end of the container)

Returns:

- void

Component

reset() : void
Resets the current field value to the originally-loaded value and clears any validation messages. Also adds emptyText...
Resets the current field value to the originally-loaded value and clears any validation messages. Also adds `emptyText` and `emptyClass` if the original value was blank.
Parameters:

- None.

Returns:

- void

TextField

resumeEvents() : void
Resume firing events. (see suspendEvents) If events were suspended using the queueSuspended parameter, then all event...
Resume firing events. (see suspendEvents) If events were suspended using the `queueSuspended` parameter, then all events fired during event suspension will be sent to any listeners now.
Parameters:

- None.

Returns:

- void

Observable

selectText( [`Number start`], [`Number end`] ) : void
Selects text in this field
Selects text in this field
Parameters:

- `start` : Number
  (optional) The index where the selection should start (defaults to 0)
- `end` : Number
  (optional) The index where the selection should end (defaults to the text length)

Returns:

- void

TextField

setActiveError( `String msg`, `Boolean suppressEvent` ) : void
Sets the current activeError to the given string. Fires the 'invalid' event. This does not set up the error icon, onl...
Sets the current activeError to the given string. Fires the 'invalid' event. This does not set up the error icon, only sets the message and fires the event. To show the error icon, use markInvalid instead, which calls this method internally
Parameters:

- `msg` : String
  The error message
- `suppressEvent` : Boolean
  True to suppress the 'invalid' event from being fired

Returns:

- void

Field

setAutoScroll( `Boolean scroll` ) : Ext.BoxComponent
Sets the overflow on the content element of the component.
Sets the overflow on the content element of the component.
Parameters:

- `scroll` : Boolean
  True to allow the Component to auto scroll.

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

setDisabled( `Boolean disabled` ) : Ext.Component
Convenience function for setting disabled/enabled by boolean.
Convenience function for setting disabled/enabled by boolean.
Parameters:

- `disabled` : Boolean

Returns:

- `Ext.Component`
  this

Component

setDisabledDates( `Array disabledDates` ) : void
Replaces any existing disabled dates with new values and refreshes the DatePicker.
Replaces any existing disabled dates with new values and refreshes the DatePicker.
Parameters:

- `disabledDates` : Array
  An array of date strings (see the `disabledDates` config for details on supported values) used to disable a pattern of dates.

Returns:

- void

DateField

setDisabledDays( `Array disabledDays` ) : void
Replaces any existing disabled days (by index, 0-6) with new values and refreshes the DatePicker.
Replaces any existing disabled days (by index, 0-6) with new values and refreshes the DatePicker.
Parameters:

- `disabledDays` : Array
  An array of disabled day indexes. See the `disabledDays` config for details on supported values.

Returns:

- void

DateField

setEditable( `Boolean value` ) : void
Allow or prevent the user from directly editing the field text. If false is passed, the user will only be able to mo...
Allow or prevent the user from directly editing the field text. If false is passed, the user will only be able to modify the field using the trigger. Will also add a click event to the text field which will call the trigger. This method is the runtime equivalent of setting the editable config option at config time.
Parameters:

- `value` : Boolean
  True to allow the user to directly edit the field text.

Returns:

- void

TriggerField

setHeight( `Mixed height` ) : Ext.BoxComponent
Sets the height of the component. This method fires the resize event.
Sets the height of the component. This method fires the resize event.
Parameters:

- `height` : Mixed
  The new height to set. This may be one of:
  - A Number specifying the new height in the Element's defaultUnits (by default, pixels).
  - A String used to set the CSS height style.
  - undefined to leave the height unchanged.

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

setHideTrigger( `Boolean hideTrigger` ) : void
Changes the hidden status of the trigger.
Changes the hidden status of the trigger.
Parameters:

- `hideTrigger` : Boolean
  True to hide the trigger, false to show it.

Returns:

- void

TriggerField

setMaxValue( `Date value` ) : void
Replaces any existing maxValue with the new value and refreshes the DatePicker.
Replaces any existing `maxValue` with the new value and refreshes the DatePicker.
Parameters:

- `value` : Date
  The maximum date that can be selected

Returns:

- void

DateField

setMinValue( `Date value` ) : void
Replaces any existing minValue with the new value and refreshes the DatePicker.
Replaces any existing `minValue` with the new value and refreshes the DatePicker.
Parameters:

- `value` : Date
  The minimum date that can be selected

Returns:

- void

DateField

setPagePosition( `Number x`, `Number y` ) : Ext.BoxComponent
Sets the page XY position of the component. To set the left and top instead, use setPosition. This method fires the ...
Sets the page XY position of the component. To set the left and top instead, use setPosition. This method fires the move event.
Parameters:

- `x` : Number
  The new x position
- `y` : Number
  The new y position

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

setPosition( `Number left`, `Number top` ) : Ext.BoxComponent
Sets the left and top of the component. To set the page XY position instead, use setPagePosition. This method fires ...
Sets the left and top of the component. To set the page XY position instead, use setPagePosition. This method fires the move event.
Parameters:

- `left` : Number
  The new left
- `top` : Number
  The new top

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

setRawValue( `Mixed value` ) : Mixed
Sets the underlying DOM field's value directly, bypassing validation. To set the value with validation see setValue.
Sets the underlying DOM field's value directly, bypassing validation. To set the value with validation see setValue.
Parameters:

- `value` : Mixed
  The value to set

Returns:

- `Mixed`
  value The field value that is set

Field

setReadOnly( `Boolean value` ) : void
Setting this to true will supersede settings editable and hideTrigger. Setting this to false will defer back to edita...
Setting this to true will supersede settings editable and hideTrigger. Setting this to false will defer back to editable and hideTrigger. This method is the runtime equivalent of setting the readOnly config option at config time.
Parameters:

- `value` : Boolean
  True to prevent the user changing the field and explicitly hide the trigger.

Returns:

- void

TriggerField

setSize( `Mixed width`, `Mixed height` ) : Ext.BoxComponent
Sets the width and height of this BoxComponent. This method fires the resize event. This method can accept either wid...
Sets the width and height of this BoxComponent. This method fires the resize event. This method can accept either width and height as separate arguments, or you can pass a size object like `{width:10, height:20}`.
Parameters:

- `width` : Mixed
  The new width to set. This may be one of:
  - A Number specifying the new width in the Element's Ext.Element.defaultUnits (by default, pixels).
  - A String used to set the CSS width style.
  - A size object in the format `{width: widthValue, height: heightValue}`.
  - `undefined` to leave the width unchanged.
- `height` : Mixed
  The new height to set (not required if a size object is passed as the first arg). This may be one of:
  - A Number specifying the new height in the Element's Ext.Element.defaultUnits (by default, pixels).
  - A String used to set the CSS height style. Animation may not be used.
  - `undefined` to leave the height unchanged.

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

setValue( `String/Date date` ) : Ext.form.Field
Sets the value of the date field. You can pass a date object or any string that can be parsed into a valid date, usi...
Sets the value of the date field. You can pass a date object or any string that can be parsed into a valid date, using `format` as the date format, according to the same rules as Date.parseDate (the default format used is `"m/d/Y"`).
Usage:

    //All of these calls set the same date value (May 4, 2006)

    //Pass a date object:
    var dt = new Date('5/4/2006');
    dateField.setValue(dt);

    //Pass a date string (default format):
    dateField.setValue('05/04/2006');

    //Pass a date string (custom format):
    dateField.format = 'Y-m-d';
    dateField.setValue('2006-05-04');

Parameters:

- `date` : String/Date
  The date or valid date string

Returns:

- `Ext.form.Field`
  this

DateField

setVisible( `Boolean visible` ) : Ext.Component
Convenience function to hide or show this component by boolean.
Convenience function to hide or show this component by boolean.
Parameters:

- `visible` : Boolean
  True to show, false to hide

Returns:

- `Ext.Component`
  this

Component

setWidth( `Mixed width` ) : Ext.BoxComponent
Sets the width of the component. This method fires the resize event.
Sets the width of the component. This method fires the resize event.
Parameters:

- `width` : Mixed
  The new width to set. This may be one of:
  - A Number specifying the new width in the Element's defaultUnits (by default, pixels).
  - A String used to set the CSS width style.

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

show() : Ext.Component
Show this component. Listen to the 'beforeshow' event and return false to cancel showing the component. Fires the '...
Show this component. Listen to the 'beforeshow' event and return `false` to cancel showing the component. Fires the 'show' event after showing the component.
Parameters:

- None.

Returns:

- `Ext.Component`
  this

Component

suspendEvents( `Boolean queueSuspended` ) : void
Suspend the firing of all events. (see resumeEvents)
Suspend the firing of all events. (see resumeEvents)
Parameters:

- `queueSuspended` : Boolean
  Pass as true to queue up suspended events to be fired after the resumeEvents call instead of discarding all suspended events;

Returns:

- void

Observable

syncSize() : Ext.BoxComponent
Force the component's size to recalculate based on the underlying element's current height and width.
Force the component's size to recalculate based on the underlying element's current height and width.
Parameters:

- None.

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

un( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes an event handler (shorthand for removeListener.)
Removes an event handler (shorthand for removeListener.)
Parameters:

- `eventName` : String
  The type of event the handler was associated with.
- `handler` : Function
  The handler to remove. This must be a reference to the function passed into the addListener call.
- `scope` : Object
  (optional) The scope originally specified for the handler.

Returns:

- void

Observable

unsetActiveError( `Boolean suppressEvent` ) : void
Clears the activeError and fires the 'valid' event. This is called internally by clearInvalid and would not usually n...
Clears the activeError and fires the 'valid' event. This is called internally by clearInvalid and would not usually need to be called manually
Parameters:

- `suppressEvent` : Boolean
  True to suppress the 'invalid' event from being fired

Returns:

- void

Field

update( `Mixed htmlOrData`, [`Boolean loadScripts`], [`Function callback`] ) : void
Update the content area of a component.
Update the content area of a component.
Parameters:

- `htmlOrData` : Mixed
  If this component has been configured with a template via the tpl config then it will use this argument as data to populate the template. If this component was not configured with a template, the components content area will be updated via Ext.Element update
- `loadScripts` : Boolean
  (optional) Only legitimate when using the html configuration. Defaults to false
- `callback` : Function
  (optional) Only legitimate when using the html configuration. Callback to execute when scripts have finished loading

Returns:

- void

Component

updateBox( `Object box` ) : Ext.BoxComponent
Sets the current box measurements of the component's underlying element.
Sets the current box measurements of the component's underlying element.
Parameters:

- `box` : Object
  An object in the format {x, y, width, height}

Returns:

- `Ext.BoxComponent`
  this

BoxComponent

validate() : Boolean
Validates the field value
Validates the field value
Parameters:

- None.

Returns:

- `Boolean`
  True if the value is valid, else false

Field

validateValue( `Mixed The` ) : Boolean
Uses getErrors to build an array of validation errors. If any errors are found, markInvalid is called with the first ...
Uses getErrors to build an array of validation errors. If any errors are found, markInvalid is called with the first and false is returned, otherwise true is returned. Previously, subclasses were invited to provide an implementation of this to process validations - from 3.2 onwards getErrors should be overridden instead.
Parameters:

- `The` : Mixed
  current value of the field

Returns:

- `Boolean`
  True if all validations passed, false if one or more failed

Field

## Public Events

Event | Defined By
--- | ---

added : ( `Ext.Component this`, `Ext.Container ownerCt`, `number index` )
Fires when a component is added to an Ext.Container
Fires when a component is added to an Ext.Container
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `ownerCt` : Ext.Container
  Container which holds the component
- `index` : number
  Position at which the component was added

Component

afterrender : ( `Ext.Component this` )
Fires after the component rendering is finished. The afterrender event is fired after this Component has been rendere...

Fires after the component rendering is finished.

The afterrender event is fired after this Component has been rendered, been postprocesed by any afterRender method defined for the Component, and, if stateful, after state has been restored.

Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

autosize : ( `Ext.form.Field this`, `Number width` )
Fires when the autoSize function is triggered. The field may or may not have actually changed size according to the d...
Fires when the `autoSize` function is triggered. The field may or may not have actually changed size according to the default logic, but this event provides a hook for the developer to apply additional logic at runtime to resize the field if needed.
Listeners will be called with the following arguments:

- `this` : Ext.form.Field
  This text field
- `width` : Number
  The new field width

TextField

beforedestroy : ( `Ext.Component this` )
Fires before the component is destroyed. Return false from an event handler to stop the destroy.
Fires before the component is destroyed. Return false from an event handler to stop the destroy.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

beforehide : ( `Ext.Component this` )
Fires before the component is hidden by calling the hide method. Return false from an event handler to stop the hide.
Fires before the component is hidden by calling the hide method. Return false from an event handler to stop the hide.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

beforerender : ( `Ext.Component this` )
Fires before the component is rendered. Return false from an event handler to stop the render.
Fires before the component is rendered. Return false from an event handler to stop the render.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

beforeshow : ( `Ext.Component this` )
Fires before the component is shown by calling the show method. Return false from an event handler to stop the show.
Fires before the component is shown by calling the show method. Return false from an event handler to stop the show.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

beforestaterestore : ( `Ext.Component this`, `Object state` )
Fires before the state of the component is restored. Return false from an event handler to stop the restore.
Fires before the state of the component is restored. Return false from an event handler to stop the restore.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `state` : Object
  The hash of state values returned from the StateProvider. If this event is not vetoed, then the state object is passed to `applyState`. By default, that simply copies property values into this Component. The method maybe overriden to provide custom state restoration.

Component

beforestatesave : ( `Ext.Component this`, `Object state` )
Fires before the state of the component is saved to the configured state provider. Return false to stop the save.
Fires before the state of the component is saved to the configured state provider. Return false to stop the save.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `state` : Object
  The hash of state values. This is determined by calling `getState()` on the Component. This method must be provided by the developer to return whetever representation of state is required, by default, Ext.Component has a null implementation.

Component

blur : ( `Ext.form.Field this` )
Fires when this field loses input focus.
Fires when this field loses input focus.
Listeners will be called with the following arguments:

- `this` : Ext.form.Field

Field

change : ( `Ext.form.Field this`, `Mixed newValue`, `Mixed oldValue` )
Fires just before the field blurs if the field value has changed.
Fires just before the field blurs if the field value has changed.
Listeners will be called with the following arguments:

- `this` : Ext.form.Field
- `newValue` : Mixed
  The new value
- `oldValue` : Mixed
  The original value

Field

destroy : ( `Ext.Component this` )
Fires after the component is destroyed.
Fires after the component is destroyed.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

disable : ( `Ext.Component this` )
Fires after the component is disabled.
Fires after the component is disabled.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

enable : ( `Ext.Component this` )
Fires after the component is enabled.
Fires after the component is enabled.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

focus : ( `Ext.form.Field this` )
Fires when this field receives input focus.
Fires when this field receives input focus.
Listeners will be called with the following arguments:

- `this` : Ext.form.Field

Field

hide : ( `Ext.Component this` )
Fires after the component is hidden. Fires after the component is hidden when calling the hide method.
Fires after the component is hidden. Fires after the component is hidden when calling the hide method.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

invalid : ( `Ext.form.Field this`, `String msg` )
Fires after the field has been marked as invalid.
Fires after the field has been marked as invalid.
Listeners will be called with the following arguments:

- `this` : Ext.form.Field
- `msg` : String
  The validation message

Field

keydown : ( `Ext.form.TextField this`, `Ext.EventObject e` )
Keydown input field event. This event only fires if enableKeyEvents is set to true.
Keydown input field event. This event only fires if `enableKeyEvents` is set to true.
Listeners will be called with the following arguments:

- `this` : Ext.form.TextField
  This text field
- `e` : Ext.EventObject

TextField

keypress : ( `Ext.form.TextField this`, `Ext.EventObject e` )
Keypress input field event. This event only fires if enableKeyEvents is set to true.
Keypress input field event. This event only fires if `enableKeyEvents` is set to true.
Listeners will be called with the following arguments:

- `this` : Ext.form.TextField
  This text field
- `e` : Ext.EventObject

TextField

keyup : ( `Ext.form.TextField this`, `Ext.EventObject e` )
Keyup input field event. This event only fires if enableKeyEvents is set to true.
Keyup input field event. This event only fires if `enableKeyEvents` is set to true.
Listeners will be called with the following arguments:

- `this` : Ext.form.TextField
  This text field
- `e` : Ext.EventObject

TextField

move : ( `Ext.Component this`, `Number x`, `Number y` )
Fires after the component is moved.
Fires after the component is moved.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `x` : Number
  The new x position
- `y` : Number
  The new y position

BoxComponent

removed : ( `Ext.Component this`, `Ext.Container ownerCt` )
Fires when a component is removed from an Ext.Container
Fires when a component is removed from an Ext.Container
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `ownerCt` : Ext.Container
  Container which holds the component

Component

render : ( `Ext.Component this` )
Fires after the component markup is rendered.
Fires after the component markup is rendered.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

resize : ( `Ext.Component this`, `Number adjWidth`, `Number adjHeight`, `Number rawWidth`, `Number rawHeight` )
Fires after the component is resized.
Fires after the component is resized.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `adjWidth` : Number
  The box-adjusted width that was set
- `adjHeight` : Number
  The box-adjusted height that was set
- `rawWidth` : Number
  The width that was originally specified
- `rawHeight` : Number
  The height that was originally specified

BoxComponent

select : ( `Ext.form.DateField this`, `Date date` )
Fires when a date is selected via the date picker.
Fires when a date is selected via the date picker.
Listeners will be called with the following arguments:

- `this` : Ext.form.DateField
- `date` : Date
  The date that was selected

DateField

show : ( `Ext.Component this` )
Fires after the component is shown when calling the show method.
Fires after the component is shown when calling the show method.
Listeners will be called with the following arguments:

- `this` : Ext.Component

Component

specialkey : ( `Ext.form.Field this`, `Ext.EventObject e` )
Fires when any key related to navigation (arrows, tab, enter, esc, etc.) is pressed. To handle other keys see Ext.Pan...
Fires when any key related to navigation (arrows, tab, enter, esc, etc.) is pressed. To handle other keys see Ext.Panel.keys or Ext.KeyMap. You can check Ext.EventObject.getKey to determine which key was pressed. For example:

    var form = new Ext.form.FormPanel({
        ...
        items: [{
                fieldLabel: 'Field 1',
                name: 'field1',
                allowBlank: false
            },{
                fieldLabel: 'Field 2',
                name: 'field2',
                listeners: {
                    specialkey: function(field, e){
                        // e.HOME, e.END, e.PAGE_UP, e.PAGE_DOWN,
                        // e.TAB, e.ESC, arrow keys: e.LEFT, e.RIGHT, e.UP, e.DOWN
                        if (e.getKey() == e.ENTER) {
                            var form = field.ownerCt.getForm();
                            form.submit();
                        }
                    }
                }
            }
        ],
        ...
    });

Listeners will be called with the following arguments:

- `this` : Ext.form.Field
- `e` : Ext.EventObject
  The event object

Field

staterestore : ( `Ext.Component this`, `Object state` )
Fires after the state of the component is restored.
Fires after the state of the component is restored.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `state` : Object
  The hash of state values returned from the StateProvider. This is passed to `applyState`. By default, that simply copies property values into this Component. The method maybe overriden to provide custom state restoration.

Component

statesave : ( `Ext.Component this`, `Object state` )
Fires after the state of the component is saved to the configured state provider.
Fires after the state of the component is saved to the configured state provider.
Listeners will be called with the following arguments:

- `this` : Ext.Component
- `state` : Object
  The hash of state values. This is determined by calling `getState()` on the Component. This method must be provided by the developer to return whetever representation of state is required, by default, Ext.Component has a null implementation.

Component

valid : ( `Ext.form.Field this` )
Fires after the field has been validated with no errors.
Fires after the field has been validated with no errors.
Listeners will be called with the following arguments:

- `this` : Ext.form.Field

Field